/*
 * pthread/pthread.c --
 *
 *      A simple program to create and join threads.
 */

#define _POSIX_C_SOURCE 200809L

#include <pthread.h>
#include <string.h>
#include <stdio.h>

typedef struct {
    pthread_t thread;
} worker_t;

static void* work(void *data)
{
    (void) data;
    return NULL;
}

int main(int argc, char *argv[])
{
    int rc;
    worker_t worker[argc];

    (void) argv;

    for (int i = 1; i < argc; i++) {
        rc = pthread_create(&worker[i].thread, NULL, work, &worker[i]);
        if (rc) {
            fprintf(stderr, "pthread_create(): %s\n", strerror(rc));
        }
    }

    for (int i = 1; i < argc; i++) {
        if (worker[i].thread) {
            rc = pthread_join(worker[i].thread, NULL);
            if (rc) {
                fprintf(stderr, "pthread_join(): %s\n", strerror(rc));
            }
        }
    }
    
    return 0;
}
